<?php
namespace Fiscal\Logic\CadastroAutomatico;

use Fiscal\Logic\ImportaTipoItem\TipoItem;
use Fiscal\Logic\ImportaGeneroProd\GeneroProduto;
use Geral\Entities\TipoItemProd;
use Geral\Entities\GeneroProd;
use Geral\Util\DateUtil;
use Geral\Util\Ambiente;
use Indeterminado\Entities\RelacProdItGen;
use Setforms2\Shared\Registry;

class RelacProdItemGenero
{
    public static function cadastraIntervaloRelac($nrorg, $cdlivromag, $cdarvprodini, $cdarvprodfin, $cdtpitemprod, $cdgenprod, $cdnaturec) {

        /*A função é responsável por realizar o cadastramento automático de um determinado intervalo de produtos na tabela RELACPRODITGEN.
          A função é executada de forma que, para os produtos do intervalo informado que já estão cadastrados, são atualizados os códigos de tipo
          de item, gênero e natureza da receita. Caso existam produtos do intervalo que não existam na tabela, estes são inseridos.*/

        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $connection->beginTransaction();

        try {
            /*Função do repositório responsável por atualizar os cadastros existentes.*/
            RelacProdItGen::atualizaIntervaloByNrorgCdlivromag($nrorg, $cdlivromag, $cdarvprodini, $cdarvprodfin, $cdtpitemprod, $cdgenprod, $cdnaturec);

            /*Função do repositório responsável por inserir os produtos novos.*/
            RelacProdItGen::insereIntervaloByNrorgCdlivromag($nrorg, $cdlivromag, $cdarvprodini, $cdarvprodfin, $cdtpitemprod, $cdgenprod, $cdnaturec);
            
            $connection->commit();
        } catch (\Exception $e) {
            $connection->rollback();
            throw $e;
        }
    }

}