<?php

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

namespace Folha\Logic\GravarPonto;

/**
 * Exclusão dos pontos das Tabelas FPA_PONTO e BATIDAPONTO
 *
 * @author phillipesilva
 */

use Folha\Entities\FpaPonto;
use Folha\Entities\Batidaponto;
use Setforms2\Shared\Registry;

class ExcluirPonto {
    public static function excluirApuracao($nrPonto, $nrOrg)
    {       
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();
        
        try{
            $ponto = FpaPonto::findOneByNrpontoAndNrorg($nrPonto, $nrOrg);
                       
            if(is_object($ponto)) {
                $ponto->delete();
            }
            
            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }
    }
    
    public static function excluirRegistros($cdEmpresa, $cdFunc, $dtBatida, $nrOrg)
    {
        //Adequa a data para a busca.
        $dtBatida = $dtBatida->format('d/m/y');
        
        $entityManager = Registry::getEntityManager();
        $db = $entityManager->getConnection();
        $db->beginTransaction();
        
        try{            
            $where = "CDFUNC = ?
                  AND CDEMPRESA = ?
                  AND NRORG = ?
                  AND TO_CHAR(DTBATIDAPTO, 'DD/MM/YY') = ?";
            
            $params = array($cdFunc, $cdEmpresa, $nrOrg, $dtBatida);            
            $pontos = Batidaponto::getObjectsByWhere($where, $params);
                       
            foreach($pontos as $ponto) {
                $ponto->delete();
            }
            
            $entityManager->flush();
            $db->commit();
        } catch (\Exception $e) {
            $db->rollback();
            throw $e;
        }
    }
}