IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CONTABILIZA_EST_SAIDA' AND
                 TYPE = 'P' 	         AND
	              U.UID = O.UID      AND
	              U.NAME = USER)
DROP PROCEDURE CONTABILIZA_EST_SAIDA
GO

CREATE PROCEDURE CONTABILIZA_EST_SAIDA(
   @P_NRLISTA    VARCHAR(10))
AS
BEGIN
   DECLARE @V_NRLANCLOTE    VARCHAR(06);
   DECLARE @V_CDLOTE        VARCHAR(20);
   DECLARE @V_IDRETORNA     VARCHAR(01);
   DECLARE @V_IDCONTCCUS    VARCHAR(01);
   DECLARE @V_NRLANCESTQ    VARCHAR(10);
   DECLARE @V_DSHISTPADR    VARCHAR(1000);
   DECLARE @V_CDEMPRESA     VARCHAR(02);
   DECLARE @V_CDHISTPADR    VARCHAR(04);


   /* VARIAVEIS DO CURSOR C_LISTA */
   DECLARE @C_LISTA_CDFILIAL     VARCHAR(4);
   DECLARE @C_LISTA_NRLANCESTQ   VARCHAR(10);

   /* VARIAVEIS DO CURSOR C_EST_SAIDA */
   DECLARE @C_EST_SAIDA_VRCUSTPROD         DOUBLE PRECISION;
   DECLARE @C_EST_SAIDA_CDFILIAL           VARCHAR(4);
   DECLARE @C_EST_SAIDA_NRLANCESTQ         VARCHAR(10);
   DECLARE @C_EST_SAIDA_CDFILIMOVI         VARCHAR(4);
   DECLARE @C_EST_SAIDA_CDCENTCUST         VARCHAR(4);
   DECLARE @C_EST_SAIDA_DTLANCMOVI         DATETIME;
   DECLARE @C_EST_SAIDA_DSLANCESTIT        VARCHAR(60);
   DECLARE @C_EST_SAIDA_CDCONTCTBL         VARCHAR(20);
   DECLARE @C_EST_SAIDA_CDCONTCTBLDEB      VARCHAR(20);
   DECLARE @C_EST_SAIDA_CDHISTPADR         VARCHAR(4);
   DECLARE @C_EST_SAIDA_NRLANCTONF         VARCHAR(10);
   DECLARE @C_EST_SAIDA_VRCUSTPRODAJUST    DOUBLE PRECISION;

   /* VARIAVEIS DO CURSOR C_DEV_NF */
   DECLARE @C_DEV_NF_VRCUSTPROD            DOUBLE PRECISION;
   DECLARE @C_DEV_NF_CDFILIAL              VARCHAR(4);
   DECLARE @C_DEV_NF_NRLANCESTQ            VARCHAR(10);
   DECLARE @C_DEV_NF_CDFILIMOVI            VARCHAR(4);
   DECLARE @C_DEV_NF_CDCENTCUST            VARCHAR(4);
   DECLARE @C_DEV_NF_DTLANCMOVI            DATETIME;
   DECLARE @C_DEV_NF_DSLANCESTIT           VARCHAR(60);
   DECLARE @C_DEV_NF_CDCONTCTBL            VARCHAR(20);
   DECLARE @C_DEV_NF_CDCONTCTBLDEB         VARCHAR(20);
   DECLARE @C_DEV_NF_CDHISTPADR            VARCHAR(4);
   DECLARE @C_DEV_NF_NRLANCTONF            VARCHAR(10);
   DECLARE @C_DEV_NF_VRCUSTPRODAJUST       DOUBLE PRECISION;

   EXEC EXCLUI_LANCCONTABIL '04',@P_NRLISTA;
   SET @V_NRLANCESTQ = '0';

   DECLARE C_LISTA CURSOR FOR (

     SELECT SUBSTRING(L.CDLISTA,1,4)  AS CDFILIAL,
               SUBSTRING(L.CDLISTA,5,10) AS NRLANCESTQ
          FROM LISTA L
         WHERE (L.NRLISTA = @P_NRLISTA))

   OPEN C_LISTA;
   FETCH NEXT FROM C_LISTA INTO @C_LISTA_CDFILIAL, @C_LISTA_NRLANCESTQ;

   WHILE (@@FETCH_STATUS = 0) BEGIN

           DECLARE C_EST_SAIDA CURSOR FOR
                 SELECT SUM(IT.VRCUSTPROD) AS VRCUSTPROD ,IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.CDCENTCUST, IT.DTLANCMOVI,
                        IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB, IT.CDHISTPADR, IT.NRLANCTONF
                   FROM (SELECT I.CDFILIAL, I.NRLANCESTQ, I.CDFILIMOVI, I.DTLANCMOVI, I.CDPRODMOVI,
                                I.QTLANCTOEST * TEKNISA.CUSTO_PRODUTO_LCEST(I.CDFILIMOVI, I.CDPRODMOVI, 3,  DTLANCMOVI, DTLANCMOVI, I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ, I.NRSUBLOTE) AS VRCUSTPROD,
                                I.DSLANCESTIT, TEKNISA.CONTCTBL_PRODUTO(I.CDPRODUTO,'E',I.CDFILIAL) AS CDCONTCTBL,
                                ISNULL(ISNULL(CT.CDCTBPRTPOPECMV,T.CDCTBLTPOPERCMV),TEKNISA.CONTCTBL_PRODUTO(I.CDPRODUTO,'M',I.CDFILIAL)) AS CDCONTCTBLDEB,
                                F.CDCENTCUST, T.CDHISTPADR, LE.NRLANCTONF
                           FROM ITLANCTOEST I, TIPOOPERAC T, FILIAL F, LANCTOESTOQ LE, CTBPRDTPOPER CT
                          WHERE (I.IDTIPOMOVI   = '4')
                            AND (I.CDFILIAL     = @C_LISTA_CDFILIAL)
                            AND (I.NRLANCESTQ   = @C_LISTA_NRLANCESTQ)
                            AND (I.CDTIPOOPER   = T.CDTIPOOPER )
                            AND (I.IDENTRSAIDOP = T.IDENTRSAIDOP)
                            AND (I.CDFILIMOVI   = F.CDFILIAL)
                            AND (I.CDFILIAL     = LE.CDFILIAL)
                            AND (I.NRLANCESTQ   = LE.NRLANCESTQ)
                            AND (CT.IDENTRSAIDOP = I.IDENTRSAIDOP)
                            AND (CT.CDTIPOOPER = I.CDTIPOOPER)) IT
                 GROUP BY IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.DTLANCMOVI,
                          IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB,IT.CDCENTCUST,
                          IT.CDHISTPADR,IT.NRLANCTONF
                 ORDER BY IT.CDFILIAL, SUM(IT.VRCUSTPROD);

           OPEN C_EST_SAIDA;
           FETCH NEXT FROM C_EST_SAIDA INTO @C_EST_SAIDA_VRCUSTPROD,  @C_EST_SAIDA_CDFILIAL,    @C_EST_SAIDA_NRLANCESTQ,
                                            @C_EST_SAIDA_CDFILIMOVI,  @C_EST_SAIDA_CDCENTCUST,  @C_EST_SAIDA_DTLANCMOVI,
                                            @C_EST_SAIDA_DSLANCESTIT, @C_EST_SAIDA_CDCONTCTBL,  @C_EST_SAIDA_CDCONTCTBLDEB,
                                            @C_EST_SAIDA_CDHISTPADR,  @C_EST_SAIDA_NRLANCTONF;

           WHILE (@@FETCH_STATUS = 0) BEGIN

                SELECT @V_CDEMPRESA = CDEMPRESA
                  FROM FILIAL
                 WHERE FILIAL.CDFILIAL = @C_EST_SAIDA_CDFILIAL;

                IF @V_NRLANCESTQ <> @C_EST_SAIDA_NRLANCESTQ BEGIN
                   EXEC GERA_LOTECONTABIL @V_CDEMPRESA, '04', '', @C_EST_SAIDA_CDFILIMOVI, @C_EST_SAIDA_DTLANCMOVI, '', '', @V_CDLOTE, @V_NRLANCLOTE;
                END;

                SELECT @V_CDHISTPADR = MAX(CDHISTPADR)
                  FROM HISTPADR;

                SET @V_DSHISTPADR = 'SAIDA ESTOQUE';

                SET @C_EST_SAIDA_VRCUSTPRODAJUST = ROUND(@C_EST_SAIDA_VRCUSTPROD,2);
                EXEC NOVA_PARTIDA @V_CDEMPRESA, @V_CDLOTE, @C_EST_SAIDA_DTLANCMOVI, @V_NRLANCLOTE, @C_EST_SAIDA_CDCONTCTBL,@C_EST_SAIDA_CDHISTPADR,
                                  @V_DSHISTPADR, @C_EST_SAIDA_VRCUSTPRODAJUST, '', '', '04', 'S';

                SELECT @V_IDCONTCCUS = IDCONTCCUS
                  FROM CONTCTBL
                 WHERE CDCONTCTBL =  @C_EST_SAIDA_CDCONTCTBL;

                IF @V_IDCONTCCUS <> 'O' BEGIN
                   SET @C_EST_SAIDA_VRCUSTPRODAJUST = ROUND(@C_EST_SAIDA_VRCUSTPROD,2);
                   EXEC RATEIO_PARTIDA @V_CDEMPRESA, @V_CDLOTE, @C_EST_SAIDA_DTLANCMOVI, @V_NRLANCLOTE, @C_EST_SAIDA_CDFILIMOVI,
                                       @C_EST_SAIDA_CDCENTCUST, @C_EST_SAIDA_VRCUSTPRODAJUST;
                END;

                SET @C_EST_SAIDA_VRCUSTPRODAJUST = ROUND(@C_EST_SAIDA_VRCUSTPROD * -1,2);
                EXEC NOVA_PARTIDA @V_CDEMPRESA,@V_CDLOTE, @C_EST_SAIDA_DTLANCMOVI, @V_NRLANCLOTE, @C_EST_SAIDA_CDCONTCTBLDEB, @C_EST_SAIDA_CDHISTPADR,
                                  @V_DSHISTPADR, @C_EST_SAIDA_VRCUSTPRODAJUST, '', '', '04', 'S';

                SELECT @V_IDCONTCCUS = IDCONTCCUS
                  FROM CONTCTBL
                 WHERE CDCONTCTBL = @C_EST_SAIDA_CDCONTCTBLDEB;

                IF @V_IDCONTCCUS <> 'O' BEGIN
                   SET @C_EST_SAIDA_VRCUSTPRODAJUST = ROUND(@C_EST_SAIDA_VRCUSTPROD * -1,2);
                   EXEC RATEIO_PARTIDA @V_CDEMPRESA, @V_CDLOTE, @C_EST_SAIDA_DTLANCMOVI, @V_NRLANCLOTE, @C_EST_SAIDA_CDFILIMOVI,
                                       @C_EST_SAIDA_CDCENTCUST, @C_EST_SAIDA_VRCUSTPRODAJUST;
                END;

                DECLARE C_DEV_NF CURSOR FOR
                   SELECT SUM(IT.VRCUSTPROD) AS VRCUSTPROD ,IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.CDCENTCUST, IT.DTLANCMOVI,
                           IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB, IT.CDHISTPADR, IT.NRLANCTONF
                      FROM (SELECT I.CDFILIAL, I.NRLANCESTQ, I.CDFILIMOVI, I.DTLANCMOVI, I.CDPRODMOVI,
                                   I.QTLANCTOEST * TEKNISA.CUSTO_PRODUTO_LCEST(I.CDFILIMOVI, I.CDPRODMOVI, 3,  I.DTLANCMOVI, I.DTLANCMOVI,
                                   I.CDALMOXARIFE, I.CDLOCALESTOQ, I.NRLOTEESTQ, I.NRSUBLOTE) AS VRCUSTPROD,
                                   I.DSLANCESTIT, TEKNISA.CONTCTBL_PRODUTO(I.CDPRODUTO,'E',I.CDFILIAL) AS CDCONTCTBL,
                                   ISNULL(ISNULL(CT.CDCTBPRTPOPECMV,TP.CDCTBLTPOPERCMV),TEKNISA.CONTCTBL_PRODUTO(I.CDPRODUTO,'M',I.CDFILIAL)) AS CDCONTCTBLDEB,
                                   F.CDCENTCUST, TP.CDHISTPADR, LE.NRLANCTONF
                              FROM ITEMNOTAFISC ITNF, NOTAFISCAL NF, TIPOOPERAC TP, ITLANCTOEST I,
                                   LANCTOESTOQ LE, FILIAL F, CTBPRDTPOPER CT
                                                               LEFT JOIN ITLANCTOEST IL
                                                                      ON CT.CDPRODUTO    = IL.CDPRODUTO
                                                                     AND CT.IDENTRSAIDOP = IL.IDENTRSAIDOP
                                                                     AND CT.CDTIPOOPER   = IL.CDTIPOOPER
                             WHERE ITNF.CDFILIALIT   = NF.CDFILIAL
                               AND ITNF.NRLANCTONF   = NF.NRLANCTONF
                               AND NF.IDENTRSAIDOP   = TP.IDENTRSAIDOP
                               AND NF.CDTIPOOPER     = TP.CDTIPOOPER
                               AND NF.CDFILIAL       = LE.CDFILIAL
                               AND NF.NRLANCTONF     = LE.NRLANCTONF
                               AND LE.CDFILIAL       = I.CDFILIAL
                               AND LE.NRLANCESTQ     = I.NRLANCESTQ
                               AND F.CDFILIAL       =  I.CDFILIMOVI
                               AND ITNF.CDFILIALIT   = @C_EST_SAIDA_CDFILIAL
                               AND ITNF.NRLANCTONFIT = @C_EST_SAIDA_NRLANCTONF
                               AND TP.IDUTCUSORIGEST = 'S') IT
                     GROUP BY IT.CDFILIAL, IT.NRLANCESTQ, IT.CDFILIMOVI, IT.DTLANCMOVI,
                             IT.DSLANCESTIT, IT.CDCONTCTBL, IT.CDCONTCTBLDEB,IT.CDCENTCUST,
                             IT.CDHISTPADR,IT.NRLANCTONF
                     ORDER BY IT.CDFILIAL, SUM(IT.VRCUSTPROD);

                   OPEN C_DEV_NF;

                   FETCH NEXT FROM C_DEV_NF INTO @C_DEV_NF_VRCUSTPROD,  @C_DEV_NF_CDFILIAL,   @C_DEV_NF_NRLANCESTQ,
                                                 @C_DEV_NF_CDFILIMOVI,  @C_DEV_NF_CDCENTCUST, @C_DEV_NF_DTLANCMOVI,
                                                 @C_DEV_NF_DSLANCESTIT, @C_DEV_NF_CDCONTCTBL, @C_DEV_NF_CDCONTCTBLDEB,
                                                 @C_DEV_NF_CDHISTPADR,  @C_DEV_NF_NRLANCTONF;
                      WHILE (@@FETCH_STATUS = 0) BEGIN
                         SELECT @V_CDEMPRESA = CDEMPRESA
                           FROM FILIAL
                          WHERE FILIAL.CDFILIAL = @C_DEV_NF_CDFILIAL;

                         IF @V_NRLANCESTQ <> @C_DEV_NF_NRLANCESTQ BEGIN
                            EXEC GERA_LOTECONTABIL @V_CDEMPRESA, '04', '', @C_DEV_NF_CDFILIMOVI, @C_DEV_NF_DTLANCMOVI, '', '', @V_CDLOTE, @V_NRLANCLOTE;
                         END;

                         SET @V_DSHISTPADR = 'DEVOLUO';

                         SET @C_DEV_NF_VRCUSTPRODAJUST = ROUND(@C_DEV_NF_VRCUSTPROD * -1,2);
                         EXEC NOVA_PARTIDA @V_CDEMPRESA, @V_CDLOTE,@C_DEV_NF_DTLANCMOVI,@V_NRLANCLOTE,@C_DEV_NF_CDCONTCTBL,@C_DEV_NF_CDHISTPADR,
                                           @V_DSHISTPADR, @C_EST_SAIDA_VRCUSTPRODAJUST,'','','04', @C_DEV_NF_NRLANCESTQ, 'N';

                         SELECT @V_IDCONTCCUS = IDCONTCCUS
                           FROM CONTCTBL
                          WHERE CDCONTCTBL = @C_EST_SAIDA_CDCONTCTBLDEB;

                         IF @V_IDCONTCCUS <> 'O' BEGIN
                            IF @C_EST_SAIDA_CDCENTCUST IS NOT NULL BEGIN
                               SET @C_DEV_NF_VRCUSTPRODAJUST = ROUND(@C_DEV_NF_VRCUSTPROD,2);
                               EXEC RATEIO_PARTIDA @V_CDEMPRESA,@V_CDLOTE,C_DEV_NF_DTLANCMOVI,V_NRLANCLOTE,C_DEV_NF_CDFILIMOVI,
                                              @C_DEV_NF_CDCENTCUST,@C_EST_SAIDA_VRCUSTPRODAJUST;
                           END;
                         END;

                         SET @C_DEV_NF_VRCUSTPRODAJUST = ROUND(@C_DEV_NF_VRCUSTPROD,2);
                         EXEC NOVA_PARTIDA @V_CDEMPRESA,@V_CDLOTE,@C_DEV_NF_DTLANCMOVI,@V_NRLANCLOTE,@C_DEV_NF_CDCONTCTBLDEB,@C_DEV_NF_CDHISTPADR,
                                           @V_DSHISTPADR, C_DEV_NF_VRCUSTPRODAJUST,'','','04', @C_DEV_NF_NRLANCESTQ,'N';

                         SELECT @V_IDCONTCCUS = IDCONTCCUS
                           FROM CONTCTBL
                          WHERE CDCONTCTBL = @C_EST_SAIDA_CDCONTCTBLDEB;

                         IF @V_IDCONTCCUS <> 'O' BEGIN
                            IF @C_EST_SAIDA_CDCENTCUST IS NOT NULL BEGIN
                               SET @C_DEV_NF_VRCUSTPRODAJUST = ROUND(@C_DEV_NF_VRCUSTPROD,2);
                               EXEC RATEIO_PARTIDA @V_CDEMPRESA,@V_CDLOTE,@C_DEV_NF_DTLANCMOVI,@V_NRLANCLOTE,@C_DEV_NF_CDFILIMOVI,
                                              @C_DEV_NF_CDCENTCUST,@C_DEV_NF_VRCUSTPRODAJUST;
                           END;
                      END;
                   FETCH NEXT FROM C_DEV_NF INTO @C_DEV_NF_VRCUSTPROD,  @C_DEV_NF_CDFILIAL,   @C_DEV_NF_NRLANCESTQ,
                                                 @C_DEV_NF_CDFILIMOVI,  @C_DEV_NF_CDCENTCUST, @C_DEV_NF_DTLANCMOVI,
                                                 @C_DEV_NF_DSLANCESTIT, @C_DEV_NF_CDCONTCTBL, @C_DEV_NF_CDCONTCTBLDEB,
                                                 @C_DEV_NF_CDHISTPADR,  @C_DEV_NF_NRLANCTONF;
                END;
                CLOSE C_DEV_NF;
                DEALLOCATE C_DEV_NF;
                SET @V_NRLANCESTQ = @C_EST_SAIDA_NRLANCESTQ;

                FETCH NEXT FROM C_EST_SAIDA INTO @C_EST_SAIDA_VRCUSTPROD,  @C_EST_SAIDA_CDFILIAL,    @C_EST_SAIDA_NRLANCESTQ,
                                                 @C_EST_SAIDA_CDFILIMOVI,  @C_EST_SAIDA_CDCENTCUST,  @C_EST_SAIDA_DTLANCMOVI,
                                                 @C_EST_SAIDA_DSLANCESTIT, @C_EST_SAIDA_CDCONTCTBL,  @C_EST_SAIDA_CDCONTCTBLDEB,
                                                 @C_EST_SAIDA_CDHISTPADR,  @C_EST_SAIDA_NRLANCTONF;
           END;

           CLOSE C_EST_SAIDA;
           DEALLOCATE C_EST_SAIDA
           INSERT INTO RELALESTLANCLOT
             (CDEMPRESA, CDLOTE, NRLANCLOTE, NRSEQLANLOTE,CDFILIAL, NRLANCESTQ)
           VALUES
             (@V_CDEMPRESA, @V_CDLOTE, @V_NRLANCLOTE, '00001', @C_LISTA_CDFILIAL, @C_LISTA_NRLANCESTQ);

           IF TEKNISA.CONFERE_PARTIDA(@V_CDEMPRESA, @V_CDLOTE, @V_NRLANCLOTE, '') = 'TRUE' BEGIN
              UPDATE LANCTOESTOQ
                 SET IDSTATUSCTBEST = 'C'
               WHERE CDFILIAL = @C_LISTA_CDFILIAL
                 AND NRLANCESTQ = @C_LISTA_NRLANCESTQ;
           END
           ELSE BEGIN
              UPDATE LANCTOESTOQ
                 SET IDSTATUSCTBEST = 'E'
               WHERE CDFILIAL = @C_LISTA_CDFILIAL
                 AND NRLANCESTQ = @C_LISTA_NRLANCESTQ;
           END;

           FETCH NEXT FROM C_LISTA INTO @C_LISTA_CDFILIAL, @C_LISTA_NRLANCESTQ;
   END;
   DELETE FROM LISTA
    WHERE NRLISTA = @P_NRLISTA;
   CLOSE C_LISTA;
   DEALLOCATE C_LISTA;
END
GO